#ifndef SPRITE_H
#define SPRITE_H

#include "include/object.h"
#include <tonc.h>

typedef struct Piece{
       int src_offset;
       int length;
  OBJ_ATTR data;
} Piece;

typedef struct Image{
  Piece * piece_start;
      int piece_count;
} Image;

typedef struct Sprite{
  const unsigned int * image_src;
               Image * image_start;
			   Image * image_inits;
                   int image_max;
	               int origin_x;
	               int origin_y;
				   int flipped;
				   int width;
} Sprite;

#define sprShadowM     0
#define sprLinkStandU  1
#define sprLinkStandD  2
#define sprLinkStandL  3
#define sprLinkStandR  4
#define sprLinkWalkU   5
#define sprLinkWalkD   6
#define sprLinkWalkL   7
#define sprLinkWalkR   8

void init_sprite_anima(Object *,int);
void draw_sprite_anima(Object *,int,int);
void draw_sprite_still(int,int,int,int);

#endif