#include "include/objLink.h"
#include "include/sprite.h"
#include <tonc.h>

void Link_Create(ObjLink *Link,int x,int y,int pal,int dir){
  Object_Create(&(Link->obj),x,y,pal,dir);
}

void Link_Step(ObjLink *Link){
  Object *obj = &(Link->obj);
  obj->keyU = (key_is_down(KEY_UP) != 0);
  obj->keyD = (key_is_down(KEY_DOWN) != 0);
  obj->keyL = (key_is_down(KEY_LEFT) != 0);
  obj->keyR = (key_is_down(KEY_RIGHT) != 0);
  direction_set(obj);
}

void Link_Draw(ObjLink *Link){
  Object *obj = &(Link->obj);
  int moving = (obj->keyU ||
                obj->keyD ||
				obj->keyL ||
				obj->keyR);
				
  if (moving){
    obj->image_speed = 0x0010;
    switch (obj->direction){
	  case 90:  init_sprite_anima(obj,sprLinkWalkU); break;
	  case 270: init_sprite_anima(obj,sprLinkWalkD); break;
	  case 180: init_sprite_anima(obj,sprLinkWalkL); break;
	  default:  init_sprite_anima(obj,sprLinkWalkR); break;
	}
  }
  else{
    obj->image_speed = 0x0001;
    switch (obj->direction){
	  case 90:  init_sprite_anima(obj,sprLinkStandU); break;
	  case 270: init_sprite_anima(obj,sprLinkStandD); break;
	  case 180: init_sprite_anima(obj,sprLinkStandL); break;
	  default:  init_sprite_anima(obj,sprLinkStandR); break;
	}
  }
  int x = obj->x >> 8;
  int y = obj->y >> 8;
  draw_sprite_anima(obj,x,y);
  draw_sprite_still(sprShadowM,4,x,y);
}