#include "include/sprRaw.h"
#include "include/sprite.h"

//****************************************************************************************************************************************************
//* sprShadowM                                                                                                                                       *
//****************************************************************************************************************************************************

static Piece p_ShadowM = {
  0,16,{0x4000,0x0000,0x0000,0}
};
static Image i_ShadowM = {
  &p_ShadowM,1
};

//****************************************************************************************************************************************************
//* sprLinkStandU                                                                                                                                    *
//****************************************************************************************************************************************************

static Piece p_LinkStandU_i[5] = { 
  { 0,16,{0x4000,0x0008,0x0140,0}},
  {16,16,{0x4008,0x0008,0x0142,0}},
  {32,16,{0x4010,0x0008,0x0144,0}},
  {48, 8,{0x0008,0x0000,0x0146,0}},
  {48, 8,{0x0008,0x1018,0x0147,0}}
};
static Image i_LinkStandU_i = { 
  &p_LinkStandU_i[0],5
};

//****************************************************************************************************************************************************
//* sprLinkStandD                                                                                                                                    *
//****************************************************************************************************************************************************

static Piece p_LinkStandD_i[4] = {
  { 0,16,{0x4000,0x0008,0x0140,0}},
  {64,16,{0x4010,0x0008,0x0144,0}},
  {80, 8,{0x0001,0x0000,0x0146,0}},
  {80, 8,{0x0001,0x1018,0x0146,0}}
};
static Image i_LinkStandD_i = { 
  &p_LinkStandD_i[0],4
};

static Piece p_LinkStandD[3][1] = { 
  {{16,16,{0x4008,0x0008,0x0142,0}}},
  {{32,16,{0x4008,0x0008,0x0142,0}}},
  {{48,16,{0x4008,0x0008,0x0142,0}}}
};
static Image i_LinkStandD[3] = { 
  {&p_LinkStandD[0][0],1},
  {&p_LinkStandD[1][0],1},
  {&p_LinkStandD[2][0],1}
};

//****************************************************************************************************************************************************
//* sprLinkStandL                                                                                                                                    *
//****************************************************************************************************************************************************

static Piece p_LinkStandL_i[3] = {
  { 0,16,{0x4000,0x0008,0x0140,0}},
  {64,16,{0x4010,0x0008,0x0144,0}},
  {80, 8,{0x0001,0x0000,0x0146,0}}
};
static Image i_LinkStandL_i = { 
  &p_LinkStandL_i[0],3
};

static Piece p_LinkStandL[3][1] = { 
  {{16,16,{0x4008,0x0008,0x0142,0}}},
  {{32,16,{0x4008,0x0008,0x0142,0}}},
  {{48,16,{0x4008,0x0008,0x0142,0}}}
};
static Image i_LinkStandL[3] = { 
  {&p_LinkStandL[0][0],1},
  {&p_LinkStandL[1][0],1},
  {&p_LinkStandL[2][0],1}
};

//****************************************************************************************************************************************************
//* sprLinkWalkU                                                                                                                                     *
//****************************************************************************************************************************************************

static Piece p_LinkWalkU_4[1][4] = {
  {{608,16,{0x4000,0x0008,0x0140,0}},{624,32,{0x4008,0x4000,0x0142,0}},{656,16,{0x4010,0x0008,0x0146,0}},{672, 8,{0x0018,0x0008,0x0148,0}}}
};
static Piece p_LinkWalkU_3[5][3] = {
  {{136,16,{0x4001,0x0008,0x0140,0}},{152,32,{0x4009,0x4000,0x0142,0}},{184,16,{0x4011,0x0008,0x0146,0}}},
  {{264,32,{0x4001,0x4000,0x0140,0}},{296,32,{0x0009,0x4008,0x0144,0}},{328, 8,{0x0019,0x0010,0x0148,0}}},
  {{336,16,{0x4002,0x0008,0x0140,0}},{352,32,{0x400A,0x4000,0x0142,0}},{384,16,{0x4012,0x0008,0x0146,0}}},
  {{480,16,{0x4001,0x0008,0x0140,0}},{496,32,{0x4009,0x4000,0x0142,0}},{528,16,{0x4011,0x0008,0x0146,0}}},
  {{680,16,{0x4002,0x0008,0x0140,0}},{696,32,{0x400A,0x4000,0x0142,0}},{384,16,{0x4012,0x1008,0x0146,0}}}
};
static Piece p_LinkWalkU_2[4][2] = {
  {{ 56,16,{0x4001,0x0008,0x0140,0}},{ 72,64,{0x4009,0x8000,0x0142,0}}},
  {{200,32,{0x4001,0x4000,0x0140,0}},{232,32,{0x0009,0x4008,0x0144,0}}},
  {{400,16,{0x4001,0x0008,0x0140,0}},{416,64,{0x4009,0x8000,0x0142,0}}},
  {{544,32,{0x4001,0x4000,0x0140,0}},{576,32,{0x0009,0x4008,0x0144,0}}}
};
static Image i_LinkWalkU[10] = {
  {&p_LinkWalkU_2[0][0],2},
  {&p_LinkWalkU_3[0][0],3},
  {&p_LinkWalkU_2[1][0],2},
  {&p_LinkWalkU_3[1][0],3},
  {&p_LinkWalkU_3[2][0],3},
  {&p_LinkWalkU_2[2][0],2},
  {&p_LinkWalkU_3[3][0],3},
  {&p_LinkWalkU_2[3][0],2},
  {&p_LinkWalkU_4[0][0],4},
  {&p_LinkWalkU_3[4][0],3}
};

//****************************************************************************************************************************************************
//* sprLinkWalkD                                                                                                                                     *
//****************************************************************************************************************************************************

static Piece p_LinkWalkD[10][2] = {
  {{ 88,64,{0x4001,0x8000,0x0140,0}},{152,32,{0x4011,0x4000,0x0148,0}}},
  {{184,64,{0x4001,0x8000,0x0140,0}},{248,16,{0x4011,0x0008,0x0148,0}}},
  {{264,32,{0x4000,0x4000,0x0140,0}},{296,32,{0x0008,0x4008,0x0144,0}}},
  {{328,32,{0x4000,0x4000,0x0140,0}},{360,32,{0x0008,0x4008,0x0144,0}}},
  {{392,32,{0x4001,0x4000,0x0140,0}},{424,32,{0x0009,0x4008,0x0144,0}}},
  {{ 88,64,{0x4001,0x8000,0x0140,0}},{152,32,{0x4011,0x5000,0x0148,0}}},
  {{456,64,{0x4001,0x8000,0x0140,0}},{248,16,{0x4011,0x1008,0x0148,0}}},
  {{264,32,{0x4000,0x4000,0x0140,0}},{520,32,{0x0008,0x4008,0x0144,0}}},
  {{328,32,{0x4000,0x4000,0x0140,0}},{552,32,{0x0008,0x4008,0x0144,0}}},
  {{392,32,{0x4001,0x4000,0x0140,0}},{584,32,{0x0009,0x4008,0x0144,0}}} 
};
static Image i_LinkWalkD[10] = {
  {&p_LinkWalkD[0][0],2},
  {&p_LinkWalkD[1][0],2},
  {&p_LinkWalkD[2][0],2},
  {&p_LinkWalkD[3][0],2},
  {&p_LinkWalkD[4][0],2},
  {&p_LinkWalkD[5][0],2},
  {&p_LinkWalkD[6][0],2},
  {&p_LinkWalkD[7][0],2},
  {&p_LinkWalkD[8][0],2},
  {&p_LinkWalkD[9][0],2}
};

//****************************************************************************************************************************************************
//* sprLinkWalkL                                                                                                                                     *
//****************************************************************************************************************************************************

static Piece p_LinkWalkL_4[1][4] = {
  {{688,32,{0x0000,0x4001,0x0140,0}},{720,16,{0x4010,0x0001,0x0144,0}},{736,16,{0x8000,0x0011,0x0146,0}},{752, 8,{0x0010,0x0011,0x0148,0}}}
};
static Piece p_LinkWalkL_3[7][3] = {
  {{168,16,{0x4001,0x0006,0x0140,0}},{184,32,{0x0009,0x4006,0x0142,0}},{216,16,{0x8001,0x0016,0x0146,0}}},
  {{232,32,{0x4000,0x4000,0x0140,0}},{264,32,{0x0008,0x4000,0x0144,0}},{296,16,{0x8008,0x0010,0x0148,0}}},
  {{312,64,{0x4000,0x8000,0x0140,0}},{376,16,{0x4010,0x0000,0x0148,0}},{392, 8,{0x0010,0x0010,0x0150,0}}},
  {{400,32,{0x0001,0x4006,0x0140,0}},{432,16,{0x4011,0x0006,0x0144,0}},{448,16,{0x8001,0x0016,0x0146,0}}},
  {{544,32,{0x0001,0x4007,0x0140,0}},{576,16,{0x4011,0x0007,0x0144,0}},{592,16,{0x8001,0x0017,0x0146,0}}},
  {{608,32,{0x4000,0x4000,0x0140,0}},{640,32,{0x0008,0x4000,0x0144,0}},{672,16,{0x8008,0x0010,0x0148,0}}},
  {{760,32,{0x0001,0x4006,0x0140,0}},{792,16,{0x4011,0x0006,0x0144,0}},{808,16,{0x8001,0x0016,0x0146,0}}}
}; 
static Piece p_LinkWalkL_2[2][2] = {
  {{ 88,64,{0x4001,0x8000,0x0140,0}},{152,16,{0x4011,0x0008,0x0148,0}}},
  {{464,64,{0x4001,0x8000,0x0140,0}},{528,16,{0x4011,0x0008,0x0148,0}}}
};
static Image i_LinkWalkL[10] = {
  {&p_LinkWalkL_2[0][0],2},
  {&p_LinkWalkL_3[0][0],3},
  {&p_LinkWalkL_3[1][0],3},
  {&p_LinkWalkL_3[2][0],3},
  {&p_LinkWalkL_3[3][0],3},
  {&p_LinkWalkL_2[1][0],2},
  {&p_LinkWalkL_3[4][0],3},
  {&p_LinkWalkL_3[5][0],3},
  {&p_LinkWalkL_4[0][0],4},
  {&p_LinkWalkL_3[6][0],3}
};

//****************************************************************************************************************************************************

Sprite allSpr[9] = {
  {sprShadowTiles,     &i_ShadowM      ,NULL           ,0, 8, 2,0,16},
  {sprLinkNormalUTiles,NULL            ,&i_LinkStandU_i,0,16,20,0,32},
  {sprLinkNormalDTiles,&i_LinkStandD[0],&i_LinkStandD_i,2,16,20,0,32},
  {sprLinkNormalLTiles,&i_LinkStandL[0],&i_LinkStandL_i,2,14,20,0,24},
  {sprLinkNormalLTiles,&i_LinkStandL[0],&i_LinkStandL_i,2,10,20,1,24},
  {sprLinkNormalUTiles,&i_LinkWalkU[0] ,NULL           ,9,16,21,0,32},
  {sprLinkNormalDTiles,&i_LinkWalkD[0] ,NULL           ,9,16,20,0,32},
  {sprLinkNormalLTiles,&i_LinkWalkL[0] ,NULL           ,9,14,21,0,32},
  {sprLinkNormalLTiles,&i_LinkWalkL[0] ,NULL           ,9,18,21,1,32}
};