#include "include/sprite.h"
#include <tonc.h>

extern OBJ_ATTR sprite_list[];
extern int sprite_count;
extern Sprite allSpr[];

static void load_image(const u32 * src,Image *img){
  int i;
  Piece *pie;
  for (i = 0; i < img->piece_count; i++){
    pie = (img->piece_start + i);
	memcpy32(tile_mem[4] + (pie->data.attr2 & 0x03FF),
	  src + pie->src_offset,
	  pie->length);
  }
}

void init_sprite_anima(Object *obj,int sprite){
  Sprite *spr;
  if (obj->sprite_index != sprite){
    spr = &allSpr[sprite];
    if (spr->image_inits)
	  load_image(spr->image_src,spr->image_inits);
    obj->sprite_index = sprite;
	obj->image_index = 0;
  }
}

static void draw_image(Sprite *spr,Image *img,int pal,int x,int y){
  int i,dx;
  Piece *pie;
  for (i = 0; i < img->piece_count; i++){
    pie = (img->piece_start + i);
	sprite_list[sprite_count].attr0 = pie->data.attr0;
	sprite_list[sprite_count].attr1 = pie->data.attr1;
	sprite_list[sprite_count].attr2 = pie->data.attr2;
	sprite_list[sprite_count].attr2 |= (pal << 12);
	dx = (sprite_list[sprite_count].attr1 & 0x01FF);
	if (spr->flipped){
	  dx = spr->width - obj_get_width(&(pie->data)) - dx;
	  sprite_list[sprite_count].attr1 |= 0x1000;
	}
	obj_set_pos(&sprite_list[sprite_count],
	  x + dx,
	  y + (sprite_list[sprite_count].attr0 & 0x00FF));
	sprite_count++;
  }
}

void draw_sprite_anima(Object *obj,int x,int y){
  Sprite *spr = &allSpr[obj->sprite_index];
  int pal = obj->palette_index;
  x -= spr->origin_x;
  y -= spr->origin_y;
  if (spr->image_inits)
    draw_image(spr,spr->image_inits,pal,x,y);
  if (spr->image_start){
    Image *img = spr->image_start;
    img += (obj->image_index >> 6);
    if ((obj->image_index & 63) == 0)
      load_image(spr->image_src,img);
    draw_image(spr,img,pal,x,y);
    obj->image_index += obj->image_speed;
    if ((obj->image_index >> 6) > spr->image_max)
      obj->image_index = 0;
  }
}

void draw_sprite_still(int sprite,int pal,int x,int y){
  Sprite *spr = &allSpr[sprite];
  x -= spr->origin_x;
  y -= spr->origin_y;
  draw_image(spr,spr->image_start,pal,x,y);
}